#!/usr/bin/perl
#
# proxy.pl
#
# Aufschlüsselung der Squidguard-Sperrungen
#
# Joachim Deckers <deckersj@mariengymnasium-arnsberg.de>, 20.09.2000
# Version vom 27.09.: mit Unterdrückung von Lehrerrechnern usw.
# angepasst von Jörg Fiebig, 25.09.2004

use strict;
use CGI qw/:standard/;

# Angabe des Netzwerkes, das für die Ausgabe berücksichtigt werden soll:
my $netprefix = "192.168";

# Liste der NETBIOS-Hostnamen für die Ausgabe
#  - für jede Schule anzupassen
my %HOSTS = ('0.21' => 'Aachen','0.22' => 'Bremen','0.23' => 'platz3',
             '0.24' => 'platz4','0.25' => 'platz5','0.26' => 'platz6',
             '0.27' => 'platz7','0.28' => 'platz8','0.29' => 'platz9',
             '0.30' => 'platz10','0.31' => 'platz11','0.32' => 'platz12',
             '0.33' => 'chemie','0.20' => 'lehrer','1.41' => 'lehrzi',
             '1.11' => 'physik','0.1' =>'arktur','0.2' => 'print-n21'
);

# Liste der Rechner, für die keine Ausgabe erfolgt (z. B. Lehrerzimmer, Sekretariat, ...)
#  - für jede Schule anzupassen
my %HIDE = ( '1.254' => 1, '0.255' => 1 );

#
# Ab hier sollten keine Anpassungen mehr notwendig sein.

# Deklarationen
my $q = new CGI;

my $accesslog = "/var/log/proxy/blocked.log";
my $suffix="";
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime();
my $ausgabe=sprintf("%02d.%02d.%4d,%02d:%02d",$mday,$mon+1,$year>80?1900+$year:2000+$year,$hour,$min); # Uhrzeit fr Ausgabe in String
my ($ip,$ips,$nutzer,$dummy,$zeit,$datum,$zone,$addr,$code,$tag,$monat,$jahr,$stunde,$minute,$sekunde,$rest,$i1,$i2,$i3,$i4,$startzeit,$endzeit,$sek,$versteckt);
my $nurhosts=0;
my %AUSGABE;
my $zaehl=0;


# Benutzerkennung merken
my $REMOTE = $q->remote_user();
my $HOST=$q->remote_host();
if ( "$REMOTE" eq "" ) { $REMOTE="anonymous" };

if ($q->param('anzeigen') eq '') { menue(); exit 0; }

# HTML Kopf ausgeben
print $q->header,
      $q->start_html(-title=>'Von Squidguard gesperrte Zugriffe auf das World Wide Web',
        -author=>'Joachim Deckers <deckersj@mariengymnasium-arnsberg>',
        -BACKGROUND=>'whttxtr2.jpg');
print $q->h1("Von Squidguard geblockte WWW-Zugriffe f&uuml;r $REMOTE auf $HOST");

# Parameter auswerten
#
# nur Hosts anzeigen?
if ($q->param('hosts')==1) { $nurhosts = 1; }
# welche Tage anzeigen?
$suffix=$q->param('suffix')-1;
if ($suffix != -1) { $suffix='.'.$suffix; } else { $suffix=''; }
# Start- und Endzeit ermitteln
$startzeit=$q->param('start');
$endzeit=$q->param('end');
if (($startzeit !~ /^\d+\:\d+\:\d+$/)&&($startzeit !~ /^\d+\:\d+$/)&&($startzeit !~ /^\d+$/)){
	print $q->p('Die Startzeit "'.$startzeit.'" wird ignoriert, da sie nicht dem Format hh:mm:ss bzw. hh:mm bzw. hh entspricht!');
	$startzeit='00:00:00';
}
if (($endzeit !~ /^\d+\:\d+\:\d+$/)&&($endzeit !~ /^\d+\:\d+$/)&&($endzeit !~ /^\d+$/)) {
	print $q->p('Die Endzeit "'.$endzeit.'" wird ignoriert, da sie nicht dem Format hh:mm:ss bzw. hh:mm bzw. hh entspricht!');
	$endzeit='23:59:59';
}
my ($s_h,$s_m,$s_s)=split(/:/,$startzeit,3);
my ($e_h,$e_m,$e_s)=split(/:/,$endzeit,3);
my $startsek = ($s_h*60+$s_m)*60+$s_s;
my $endsek = ($e_h*60+$e_m)*60+$e_s;

# zunächst nur das Datum auslesen 
# - für Zugriffe zwischen 0 Uhr und vor logrotate (standard: 2 Uhr) ist das
#   Datum falsch, da nur der erste Eintrag berücksichtigt wird. Diese würden also
#   noch dem Vortag zugerechnet.
#   Aber wer surft schon um die Zeit in der Schule...
open ALOG,"<$accesslog$suffix";
$_=<ALOG>;
close ALOG;
  ($datum,$zeit,$dummy,$dummy,$addr,$ips) = split (/ /,$_,6);
  $datum =~ s/\[//g;
  $zeit =~ s/\[//g;
  ($ip,$dummy)=split(/\//,$ips,2);
  ($jahr,$monat,$tag)=split(/-/,$datum,3);
  ($stunde,$minute,$sekunde)=split(/:/,$zeit,3);
print "<b>Datum: $tag.$monat.$jahr, Zeit: $startzeit - $endzeit </b><br>\n";
print "<BR>";

#Logdatei einlesen
print '<table border="0"><tr><th>Platz</th><th>Nutzer</th><th>Zeit</th><th>URL</th></tr>'."\n";
open ALOG,"<$accesslog$suffix";
while (<ALOG>) {
  chomp;
  ($datum,$zeit,$dummy,$dummy,$addr,$ips,$nutzer,$dummy) = split (/ /,$_,8);
  $datum =~ s/\[//g;
  $zeit =~ s/\[//g;
  ($ip,$dummy)=split(/\//,$ips,2);
  ($jahr,$monat,$tag)=split(/-/,$datum,3);
  ($stunde,$minute,$sekunde)=split(/:/,$zeit,3);
#  ($dummy,$zeit,$dummy,$dummy,$addr,$ip) = split (/ /,$_,6);
#  $zeit =~ s/\[//g;
#  ($tag,$monat,$jahr,$rest)=split(/\/|:/,$zeit,4);
#  ($stunde,$minute,$sekunde)=split(/:/,$rest,3);
  $sek = ($stunde*60+$minute)*60+$sekunde;
  if ( ($sek>=$startsek) && ($sek<=$endsek)  ) { # Innerhalb des Zeitintervalls?
#	  ($dummy,$addr,$code) = split (/\"/,$addr,3);
	  ($i1,$i2,$i3,$i4) = split (/\./,$ip,4);
	  if ($netprefix eq "$i1\.$i2") { # aus dem richtigen Netz heraus?
	          if ($HOSTS{"$i3\.$i4"} ne "") { $ip=$HOSTS{"$i3\.$i4"}; }
	      $addr =~ s/(.*)GET (.*) HT(.*)$/$2/;
	      $code =~ s/(\w*)(\d{3})(.*)$/$2/;
	      if ( !$HIDE{"$i3\.$i4"} ) { # Lehrerrechner usw. ggf. nicht anzeigen!
  	        if (!$nurhosts) # nur Startadressen auf Rechnern berücksichtigen
	          { if ( $addr =~ /\/$/ || $addr =~ /\.htm/i || $addr =~ /\.html/i) {
	            $AUSGABE{$zaehl++} = "$ip,$nutzer,$stunde:$minute:$sekunde,$code,$addr";}
#	            print "<tr><td>$ip</td><td>$nutzer</td><td>$stunde:$minute:$sekunde</td><td><a href=\"$addr\" target=\"_blank\">".(($code>=301)?'<font color="'.(($code==407)?'fuchsia':($code==403)?'red':($code==301)?'green':'darkred').'">':'').$addr.(($code>=301)?'</font>':'')."</a></td></tr>\n"; }
	          }
	        else { # alle html-Dateien berücksichtigen
	         if ( $addr =~ /^.*\/\/[0-9|a-z|\.|\-]*\/$/i ) {
	            $AUSGABE{$zaehl++} = "$ip,$nutzer,$stunde:$minute:$sekunde,$code,$addr"; }
#	            print "<tr><td>$ip</td><td>$nutzer</td><td>$stunde:$minute:$sekunde</td><td><a href=\"$addr\" target=\"_blank\">".(($code>=301)?'<font color="'.(($code==407)?'fuchsia':($code==403)?'red':($code==301)?'green':'darkred').'">':'').$addr.(($code>=301)?'</font>':'')."</a></td></tr>\n"; }
	        }   
	      } 
	      else { $HIDE{"$i3\.$i4"}++; } # aha, es wurden Einträge unterdrückt.
	  }
  } 
}
close ALOG;

if ($q->param('sortierung') eq 'zeit') {
	foreach (sort { $a <=> $b } keys %AUSGABE) {
	  ($ip,$nutzer,$zeit,$code,$addr) = split(/,/,$AUSGABE{$_},5);
	  print "<tr><td>$ip</td><td>$nutzer</td><td>$zeit</td><td><a href=\"$addr\" target=\"_blank\"><font color=\"red\">".$addr."<font></a></td></tr>\n"; 	  	  
	}
} elsif ($q->param('sortierung') eq 'platz') {
	foreach (sort nach_platz keys %AUSGABE) {
	  ($ip,$nutzer,$zeit,$code,$addr) = split(/,/,$AUSGABE{$_},5);
	  print "<tr><td>$ip</td><td>$nutzer</td><td>$zeit</td><td><a href=\"$addr\" target=\"_blank\"><font color=\"red\">".$addr."<font></a></td></tr>\n";
	}
}
elsif ($q->param('sortierung') eq 'url') {
	foreach (sort nach_url keys %AUSGABE) {
	  ($ip,$nutzer,$zeit,$code,$addr) = split(/,/,$AUSGABE{$_},5);
	  print "<tr><td>$ip</td><td>$nutzer</td><td>$zeit</td><td><a href=\"$addr\" target=\"_blank\"><font color=\"red\">".$addr."<font></a></td></tr>\n"; 	  	  
	}
}
# HTML Ende der Ausgabe
print "</table><HR>\n";
# Ggf. auf nicht berücksichtigte Einträge hinweisen
$versteckt = 0;
foreach (keys %HIDE) { if ($HIDE{$_} > 1) {$versteckt++;} }
if ($versteckt) {
  print "<SMALL>Zugriffe folgender Rechner wurden nicht angezeigt:<BR><I>\n";
  foreach (keys %HIDE) { if ($HIDE{$_} > 1) {print "&nbsp;&nbsp;".(($HOSTS{"$_"} ne "") ? $HOSTS{$_}:"$netprefix\.$_");} }
}
print "</I><BR><HL>Zuletzt ge&auml;ndert am : 26.09.2004 &copy; J&ouml;rg Fiebig, Joachim Deckers </SMALL><BR>\n";
print "<a href=\"index.htm\" target=_top><img src=\"back.gif\" border=0> Zur&uuml;ck </a><br>\n";
print "</BODY></HTML>\n";

# nach_platz()
# Vergleich zweier Einträge 1. nach Platz und 2. nach Zeit
sub nach_platz() {
  my ($dum,$ip1,$ip2, $z1, $z2);
  ($ip1,$z1,$dum)=split(/,/,$AUSGABE{$a},3);
  ($ip2,$z2,$dum)=split(/,/,$AUSGABE{$b},3);
  if ($ip1 eq $ip2) { return $z1 cmp $z2; }
  else { return $ip1 cmp $ip2 };
}

# nach_url()
# Vergleich zweier Einträge 1. nach URL und 2. nach Zeit
sub nach_url() {
  my ($dum,$u1,$u2, $z1, $z2);
  ($dum,$z1,$dum,$u1)=split(/,/,$AUSGABE{$a},4);
  ($dum,$z2,$dum,$u2)=split(/,/,$AUSGABE{$b},4);
  if ($u1 eq $u2) { return $z1 cmp $z2; }
  else { return $u1 cmp $u2 };
}


#
# menue()
#
# Ausgabe eine HTML-Forms für die Anzeigeoptionen
#
sub menue() {
my (%labels,$i);
my %slabels = ('zeit'=>'Zugriffszeit','platz'=>'lokalem Rechner','url'=>'aufgerufener URL');

for ($i=0;$i<=10;++$i) {
        $labels{"$i"} = ($i>0) ? "vor $i Tagen":"heute";
}

print $q->header,
      $q->start_html(-title=>'von Squidguard geblockte Proxy-Zugriffe auf das World Wide Web',
        -author=>'Joachim Deckers <deckersj@mariengymnasium-arnsberg>',
        -BACKGROUND=>'whttxtr2.jpg'),
      $q->h1("Auswertung der SQUIDGUARD-Sperren"),
      $q->startform('POST',$q->url(),'application/x-www-form-urlencoded'),
	  $q->p('F&uuml;r welche Tage und Zeiten sollen die geblockten Dateien angezeigt werden?'),
      '<table><tr><td width="50%">',
      $q->p('Tag: ',$q->popup_menu('suffix',[0,1,2,3,4,5,6,7,8,9,10],'0',\%labels)),
      $q->p('Startzeit: ',$q->textfield(-name=>'start',-default=>'00:00:00',-override=>1,-size=>8,-maxlength=>8)),
      $q->p('Endzeit: ',$q->textfield(-name=>'end',-default=>'23:59:59',-override=>1,-size=>8,-maxlength=>8)),
      $q->p($q->checkbox('hosts','checked','1','Nur Startseiten auf Hosts anzeigen')),
      '</td><td>',
      $q->p('Sortieren nach <BR>',$q->radio_group('sortierung',['zeit','platz','url'],'zeit','true',\%slabels)),
      # $q->p('Automatisch alle',$q->textfield('refresh','0',3,5),' Sekunden aktualisieren (0 f&uuml;r keine Aktualisierung).'),
      '</td></tr></table>',
      $q->hidden('anzeigen','ja'),
      $q->p($q->submit('submit','Abfragen'),'   ',$q->defaults('Zurcksetzen')),
      $q->endform(),
      "<HR><SMALL>R&uuml;ckfragen zum Skript an <A HREF=\"mailto:deckersj\@mariengymnasium-arnsberg.de\">Joachim Deckers</A>.</BODY></HTML>";
}